Imports System.IO
Imports System.Runtime.InteropServices

Public Class FormMain

    ' [{bNXc[̕ێf[^
    Public Class TreeNodeData
        Public Path As String
        Public Separate As Char
        Public Flag As Integer
        Public Sub New(ByVal path_name As String, ByVal separate_char As Char, ByVal flag_data As Integer)
            Path = path_name
            Separate = separate_char
            Flag = flag_data
        End Sub
    End Class

    ' [{bNXc[̉摜ԍ
    Enum IconImage
        User
        Inbox
        Sent
        Trash
        Folder
        NoSelect
    End Enum
    Private Const ContinueTimerCount As Integer = 10 '60*25
    ' [T[o̐ݒ
    Public Class MailParameter
        Public Smtp As String
        Public SmtpPort As Integer
        Public SmtpSsl As Integer
        Public SmtpAuth As Integer
        Public Imap4 As String
        Public Imap4Port As Integer
        Public Imap4Ssl As Integer
        Public Imap4Auth As Integer
        Public Address As String
    End Class
    Private Const XmlFileName As String = "vbnetimap4param.xml"
    Private Id As String = ""
    Private Password As String = ""
    Private MailBox As String = ""
    Private TrashMailBox As String = ""
    Private SentMailBox As String = ""
    Private FirstFlag As Boolean = True
    Private DeleteFlag As Boolean = False
    Private MailParam As MailParameter
    Private TimerCount As Integer
    Private imap As nMail.Imap4

    Private Sub FormMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MailParam = New MailParameter
        MailParam.Imap4 = ""
        MailParam.Imap4Port = nMail.Imap4.StandardPortNo
        MailParam.Imap4Ssl = 0
        MailParam.Imap4Auth = nMail.Imap4.AuthPlain
        MailParam.Smtp = ""
        MailParam.SmtpPort = nMail.Smtp.StandardPortNo
        MailParam.SmtpSsl = 0
        MailParam.SmtpAuth = 0
        MailParam.Address = ""
        If File.Exists(XmlFileName) Then
            Dim serializer As System.Xml.Serialization.XmlSerializer = New System.Xml.Serialization.XmlSerializer(GetType(MailParameter))
            Dim fs As FileStream = New FileStream(XmlFileName, FileMode.Open)
            MailParam = CType(serializer.Deserialize(fs), MailParameter)
            fs.Close()
        End If
        ' 
        nMail.Winsock.Initialize()
        nMail.Options.EnableConnectTimeout()
        ' IMAP4
        imap = New nMail.Imap4
        ' UID gp
        imap.UseUid = True
        ' IDLE ݒ
        AddHandler imap.IdleEvent, AddressOf ReceiveEvent
        ' [{bNX
        MailBox = "INBOX"
        ' NoOperation ^C}
        TimerCount = 0
    End Sub

    Private Delegate Sub ReceiveEventDelegate(ByVal sender As Object, e As System.EventArgs)

    Private Sub ReceiveEvent(ByVal sender As Object, ByVal e As System.EventArgs)
       If InvokeRequired Then
            BeginInvoke(New ReceiveEventDelegate(AddressOf ReceiveEvent), New Object() {sender, e})
       Else
            GetMailList()
            imap.StartIdle()
       End If
    End Sub

    Private Sub FormMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If DeleteFlag Then
            imap.Expunge()
        End If
        imap.Close()
        nMail.Winsock.Done()
    End Sub

    ' IMAP4 F
    ' łɐڑς݂Ȃ炻̂܂ܖ߂
    Private Function Authenticate() As Boolean
        TimerCount = ContinueTimerCount
        ' ڑH
        If Not imap.IsConnected() Then
            Try
                ' SSL ݒ
                imap.SSL = MailParam.Imap4Ssl
                ' ڑ
                imap.Connect(MailParam.Imap4, MailParam.Imap4Port)
                ' F
                imap.Authenticate(Id, Password, MailParam.Imap4Auth)
                Return True
            Catch nex As nMail.nMailException
                If nex.ErrorCode = nMail.Imap4.ErrorAuthenticate Then
                    MessageBox.Show(String.Format("F؃G[łB{0}", nex.Message))
                    Id = ""
                    Password = ""
                Else
                    MessageBox.Show(String.Format("T[o[ڑɃG[܂B{0}", nex.Message))
                End If
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
            End Try
            ' G[Ȃ
            imap.Close()
            Return False
        End If
        Return True
    End Function

    ' ̂̃[{bNXo^ς݂H
    Private Function SearchNode(ByVal node As TreeNode, ByVal path As String) As TreeNode
        For Each tn As TreeNode In node.Nodes
            Dim ctn As TreeNode
            ctn = SearchNode(tn, path)
            If Not ctn Is Nothing Then
                Return ctn
            End If
            If Not tn.Tag Is Nothing Then
                Dim data As TreeNodeData = CType(tn.Tag, TreeNodeData)
                If String.Compare(data.Path, path, True) = 0 Then
                    Return tn
                End If
            End If
        Next
        Return Nothing
    End Function

    ' [{bNXc[ɒǉ
    Private Sub AddTree(ByVal name As String, ByVal separate As Char, ByVal flag As Integer)
        Dim no As Integer
        Dim node As TreeNode
        Dim parent_node As TreeNode
        Dim path As String
        Dim folder As String() = name.Split(separate)

        parent_node = TreeMailBox.TopNode
        TreeMailBox.PathSeparator = separate.ToString()
        For no = 0 To folder.Length - 1
            path = String.Join(separate.ToString(), folder, 0, no + 1)
            node = SearchNode(TreeMailBox.TopNode, path)
            If node Is Nothing Then
                Dim index As Integer
                Dim text As String = folder(no)
                index = CType(IconImage.Folder, Integer)
                ' IłȂ[{bNX
                If (flag And nMail.Imap4.MailBoxNoSelect) <> 0 Then
                    index = CType(IconImage.NoSelect, Integer)
                End If
                If no = 0 Then
                    If String.Compare(text, "inbox", True) = 0 Then
                        text = "M"
                        index = IconImage.Inbox
                    ElseIf String.Compare(text, "sent", True) = 0 Then
                        SentMailBox = text
                        text = "M"
                        index = IconImage.Sent
                    ElseIf String.Compare(text, "trash", True) = 0 Then
                        TrashMailBox = text
                        text = "S~"
                        index = IconImage.Trash
                    End If
                End If
                Dim insert_no As Integer = 0
                For Each tn As TreeNode In parent_node.Nodes
                    If index < tn.ImageIndex Then
                        Exit For
                    End If
                    insert_no = insert_no + 1
                Next
                node = New TreeNode(text, index, index)
                parent_node.Nodes.Insert(insert_no, node)
                node.Tag = New TreeNodeData(path, separate, flag)
                parent_node.Expand()
            Else
                Dim data As TreeNodeData = CType(node.Tag, TreeNodeData)
                If (data.Path = name) And (flag <> data.Flag) Then
                    data.Flag = flag
                    node.Tag = data
                    If (flag And nMail.Imap4.MailBoxNoSelect) <> 0 Then
                        node.ImageIndex = IconImage.NoSelect
                        node.SelectedImageIndex = IconImage.NoSelect
                    End If
                End If
            End If
            parent_node = node
        Next
    End Sub

    ' [{bNXc[r[ɕ\
    Private Function GetMailBoxTree() As Boolean
        TreeMailBox.Nodes.Clear()
        If Authenticate() Then
            Try
                Dim add_node As TreeNode = TreeMailBox.Nodes.Add(MailParam.Address)
                add_node.ImageIndex = IconImage.User
                ' [{bNXꗗ
                imap.GetMailBoxList("", "*")
                Dim mailbox_list As nMail.Imap4.MailBoxStatus() = imap.GetMailBoxStatusList()
                For Each mailbox As nMail.Imap4.MailBoxStatus In mailbox_list
                    If TreeMailBox.TopNode.Tag Is Nothing Then
                        TreeMailBox.TopNode.Tag = New TreeNodeData("", mailbox.Separate, 0)
                    End If
                    ' c[r[ɍڒǉ
                    AddTree(mailbox.Name, mailbox.Separate, mailbox.Flag)
                Next
                ' INBOX I
                TreeMailBox.SelectedNode = SearchNode(TreeMailBox.TopNode, MailBox)
                Return True
            Catch nex As nMail.nMailException
                MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
            End Try
        End If
        Return False
    End Function

    ' ݑI𒆂̃[{bNX̃[ꗗ\
    Private Sub GetMailList()
        ' ID ͂Ȃ̓_CAO\
        If Id = "" Then
            If Not InputId() Then
                Return
            End If
        End If
        ' [{bNXꗗ܂\ĂȂ
        ' 擾ĕ\
        If TreeMailBox.TopNode Is Nothing Then
            If Not GetMailBoxTree() Then
                Return
            End If
        End If

        TextBody.Text = ""
        ListMail.Items.Clear()
        ListAttach.Visible = False
        If MailBox <> "" Then
            If Authenticate() Then
                Try
                    If DeleteFlag Then
                        ' 폜tÔ[폜
                        imap.Expunge()
                        DeleteFlag = False
                    End If
                    ' [{bNXI
                    imap.SelectMailBox(MailBox)
                    ' [{bNX̍폜}[NȂ̃[ UID 擾
                    imap.Search(nMail.Imap4.SearchUnDeleted)
                    Dim result_list As Integer() = imap.GetSearchMailResultList()
                    For Each uid As Integer In result_list
                        ' [̃Xe[^X擾
                        imap.GetStatus(uid)
                        ' .NET Framework 2.0 ȍ~łȂƃI[i[h[ʓ|Ȃ悤Ȃ̂ŁA
                        ' Ƃ肠ǂ""ƕ\邱Ƃ
                        Dim seen As String = ""
                        Dim attach As String = ""
                        If (imap.MessageFlag And nMail.Imap4.MessageSeen) = 0 Then
                            seen = ""
                        End If
                        If imap.GetAttachmentFileStatus(uid) Then
                            attach = "Y"
                        End If
                        Dim item As String() = {seen, attach, imap.Subject, imap.From, imap.DateString}
                        Dim add_item As ListViewItem = ListMail.Items.Add(New ListViewItem(item))
                        ' UID ACeɕۑ
                        add_item.Tag = uid
                    Next
                Catch nex As nMail.nMailException
                    If nex.ErrorCode = nMail.Imap4.ErrorSocket Then
                        imap.Close()
                    Else
                        MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
                    End If
                Catch ex As Exception
                    Debug.WriteLine(ex.Message)
                End Try
            End If
        End If
    End Sub

    ' ID ƃpX[h
    Private Function InputId() As Boolean
        Dim form As FormId = New FormId

        form.Id = Id
        form.Password = Password
        If form.ShowDialog() = DialogResult.OK Then
            Id = form.Id
            Password = form.Password
            If (Id <> "") And (Password <> "") Then
                Return True
            End If
        End If
        Return False
    End Function

    ' gqɑΉACR擾p API ֘A̐錾
    <DllImport("shell32.dll")> _
    Public Shared Function SHGetFileInfo(ByVal pszPath As String, ByVal dwFileAttributes As Integer, ByRef psfi As SHFILEINFO, ByVal cbSizeFileInfo As Integer, ByVal uFlags As Integer) As IntPtr
    End Function
    Private Const SHGFI_ICON As Integer = &H100
    Private Const SHGFI_SMALLICON As Integer = &H1
    Private Const SHGFI_USEFILEATTRIBUTES As Integer = &H10
    Public Structure SHFILEINFO
        Public hIcon As IntPtr
        Public iIcon As IntPtr
        Public dwAttributes As Integer
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=260)> _
        Public szDisplayName As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=80)> _
        Public szTypeName As String
    End Structure

    Private Sub FormMain_Activated(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Activated
        If FirstFlag Then
            FirstFlag = False
            If (MailParam.Imap4 = "") Or (MailParam.Imap4Port = 0) Then
                MenuOption_Click(sender, e)
            End If
            If MailParam.Imap4 <> "" Then
                Try
                    GetMailList()
                    imap.StartIdle()
                Catch ex As Exception
                    Debug.WriteLine(ex.Message)
                End Try
            End If
        End If
    End Sub

    Private Sub MenuCreate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuCreate.Click
        Dim form As FormWrite = New FormWrite

        form.HostName = MailParam.Smtp
        form.From = MailParam.Address
        form.SSL = MailParam.SmtpSsl
        form.PortNo = MailParam.SmtpPort
        form.Auth = MailParam.SmtpAuth
        form.Id = Id
        form.Password = Password
        If form.ShowDialog() = DialogResult.OK Then
            ' Mσ[{bNXΑMς݂̃[Abv[h
            AppendSent(form.Subject, MailParam.Address, form.ToText, form.Body, form.FileName)
        End If
    End Sub

    Private Sub MenuRedisp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuRedisp.Click
        FirstFlag = False
        Try
            GetMailList()
            imap.StartIdle()
        Catch ex As Exception
            Debug.WriteLine(ex.Message)
        End Try
    End Sub

    Private Sub MenuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuExit.Click
        Close()
    End Sub

    Private Sub MenuOption_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuOption.Click
        Dim form As FormOption = New FormOption

        form.Imap4 = MailParam.Imap4
        form.Imap4Port = MailParam.Imap4Port
        form.Imap4Ssl = MailParam.Imap4Ssl
        form.Imap4Auth = MailParam.Imap4Auth
        form.Smtp = MailParam.Smtp
        form.SmtpPort = MailParam.SmtpPort
        form.SmtpSsl = MailParam.SmtpSsl
        form.SmtpAuth = MailParam.SmtpAuth
        form.Address = MailParam.Address
        If form.ShowDialog() = DialogResult.OK Then
            MailParam.Imap4 = form.Imap4
            MailParam.Imap4Port = form.Imap4Port
            MailParam.Imap4Ssl = form.Imap4Ssl
            MailParam.Imap4Auth = form.Imap4Auth
            MailParam.Smtp = form.Smtp
            MailParam.SmtpPort = form.SmtpPort
            MailParam.SmtpSsl = form.SmtpSsl
            MailParam.SmtpAuth = form.SmtpAuth
            MailParam.Address = form.Address

            Dim serializer As System.Xml.Serialization.XmlSerializer = New System.Xml.Serialization.XmlSerializer(GetType(MailParameter))
            Dim fs As FileStream = New FileStream(XmlFileName, FileMode.Create)
            serializer.Serialize(fs, MailParam)
            fs.Close()
        End If
    End Sub

    ' Mσ[{bNXΑMς݂̃[Abv[h
    Private Sub AppendSent(ByVal subject As String, ByVal from As String, ByVal to_text As String, ByVal body As String, ByVal filename As String)
        ' Mσ[{bNX邩H
        If SentMailBox <> "" Then
            If Authenticate() Then
                Try
                    Dim header As String
                    header = "Subject: " + subject + ControlChars.CrLf
                    header += "From: " + from + ControlChars.CrLf
                    header += "To: " + to_text + ControlChars.CrLf
                    imap.AppendMail(SentMailBox, header, body, nMail.Imap4.MessageSeen, filename)
                    imap.StartIdle()
                Catch nex As nMail.nMailException
                    MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
                Catch ex As Exception
                    Debug.WriteLine(ex.Message)
                End Try
            End If
        End If
    End Sub

    Private Sub MenuReply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuReply.Click
        If ListMail.SelectedItems.Count > 0 Then
            Dim form As FormWrite = New FormWrite()

            form.HostName = MailParam.Smtp
            form.From = MailParam.Address
            form.Subject = "Re:" + ListMail.SelectedItems(0).SubItems(2).Text
            form.ToText = ListMail.SelectedItems(0).SubItems(3).Text
            form.SSL = MailParam.SmtpSsl
            form.PortNo = MailParam.SmtpPort
            form.Auth = MailParam.SmtpAuth
            form.Id = Id
            form.Password = Password
            If form.ShowDialog() = DialogResult.OK Then
                ' Mσ[{bNXΑMς݂̃[Abv[h
                AppendSent(form.Subject, MailParam.Address, form.ToText, form.Body, form.FileName)
            End If
        End If
    End Sub

    Private Sub MenuDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuDelete.Click
        If Authenticate() Then
            Try
                Dim item As ListViewItem = ListMail.SelectedItems(0)
                Dim uid As Integer = CType(item.Tag, Integer)
                If (TrashMailBox <> "") And (MailBox <> TrashMailBox) Then
                    imap.Copy(uid, TrashMailBox)
                End If
                imap.Delete(uid)
                ListMail.Items.Remove(ListMail.SelectedItems(0))
                DeleteFlag = True
                imap.StartIdle()
            Catch nex As nMail.nMailException
                MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
            End Try
        End If
    End Sub

    Private Sub MenuProperty_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuProperty.Click
        If Authenticate() Then
            Try
                ' UID 擾
                Dim uid As Integer = CType(ListMail.SelectedItems(0).Tag, Integer)
                imap.GetStatus(uid)
                ' MIME \擾
                imap.GetMimeStructure(uid)
                Dim form As FormProperty = New FormProperty
                form.Header = imap.Header
                Dim MimeList As nMail.Imap4.MimeStructureStatus() = imap.GetMimeStructureStatusList()
                ' MIME \̒ǉ
                For Each mime As nMail.Imap4.MimeStructureStatus In MimeList
                    Dim no As Integer
                    Dim text As String
                    text = mime.Type + "/" + mime.SubType + "; "
                    For no = 0 To mime.Parameter.Length - 1
                        text += mime.Parameter(no).Name + "=" + mime.Parameter(no).Value
                        If no < mime.Parameter.Length - 1 Then
                            text += "; "
                        End If
                    Next no
                    form.AddTreeItem(mime.Part, text)
                Next
                imap.StartIdle()
                form.ShowDialog()
            Catch nex As nMail.nMailException
                MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
            End Try
        End If
    End Sub

    Private Sub MenuOpenAttach_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuOpenAttach.Click
        If Authenticate() Then
            Try
                Dim uid As Integer = CType(ListMail.SelectedItems(0).Tag, Integer)
                Dim part_no As Integer = CType(ListAttach.SelectedItems(0).Tag, Integer)
                Dim name As String = Path.GetTempPath() + ListAttach.SelectedItems(0).Text
                ' Ytt@Ce|tH_ɕۑ
                imap.SaveMimePart(uid, part_no, name)
                ' ۑt@CJ
                Process.Start(name)
                imap.StartIdle()
            Catch nex As nMail.nMailException
                MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
            End Try
        End If
    End Sub

    Private Sub MenuSaveAttach_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuSaveAttach.Click
        If Authenticate() Then
            Try
                Dim uid As Integer = CType(ListMail.SelectedItems(0).Tag, Integer)
                Dim part_no As Integer = CType(ListAttach.SelectedItems(0).Tag, Integer)
                SaveFileDialog.FileName = ListAttach.SelectedItems(0).Text
                ' t@Cۑ_CAO\
                If SaveFileDialog.ShowDialog() = DialogResult.OK Then
                    'Ytt@Cۑ
                    imap.SaveMimePart(uid, part_no, SaveFileDialog.FileName)
                    imap.StartIdle()
                End If
            Catch nex As nMail.nMailException
                MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
            End Try
        End If
    End Sub

    Private Sub MenuCreateMailBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuCreateMailBox.Click
        If Not TreeMailBox.SelectedNode Is Nothing Then
            Dim data As TreeNodeData = CType(TreeMailBox.SelectedNode.Tag, TreeNodeData)
            ' q[{bNX쐬ł邩H
            If (data.Flag And nMail.Imap4.MailBoxNoInferious) = 0 Then
                Dim form As FormName = New FormName
                ' [{bNX̓_CAO\
                If form.ShowDialog() = DialogResult.OK Then
                    If Authenticate() Then
                        Try
                            Dim path As String = ""
                            If data.Path <> "" Then
                                path = data.Path + data.Separate
                            End If
                            path = path + form.MailBox
                            ' [{bNX쐬
                            imap.CreateMailBox(path)

                            Dim index As Integer
                            Dim text As String
                            index = IconImage.Folder
                            text = form.MailBox
                            ' sent ̏ꍇMσ[{bNXƂĈ
                            If String.Compare(path, "sent", True) = 0 Then
                                SentMailBox = path
                                text = "M"
                                index = IconImage.Sent
                                ' trash ̏ꍇS~ƂĈ
                            ElseIf String.Compare(text, "trash", True) = 0 Then
                                TrashMailBox = path
                                text = "S~"
                                index = IconImage.Trash
                            End If
                            Dim add_node As TreeNode = TreeMailBox.SelectedNode.Nodes.Add(text)
                            add_node.ImageIndex = index
                            add_node.SelectedImageIndex = index
                            add_node.Tag = New TreeNodeData(path, data.Separate, 0)
                            TreeMailBox.SelectedNode.Expand()
                            imap.StartIdle()
                        Catch nex As nMail.nMailException
                            MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
                        Catch ex As Exception
                            Debug.WriteLine(ex.Message)
                        End Try
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub MenuRenameMailBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuRenameMailBox.Click
        If Not TreeMailBox.SelectedNode Is Nothing Then
            TreeMailBox.SelectedNode.BeginEdit()
        End If
    End Sub

    ' q[{bNX̍폜
    Private Sub DeleteChildMailBox(ByVal node As TreeNode)
        For Each tn As TreeNode In node.Nodes
            DeleteChildMailBox(tn)
            If Not tn.Tag Is Nothing Then
                Dim data As TreeNodeData = CType(tn.Tag, TreeNodeData)
                imap.DeleteMailBox(data.Path)
            End If
        Next
    End Sub

    Private Sub MenuDeleteMailBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuDeleteMailBox.Click
        If Authenticate() Then
            Try
                ' MAMρAS~͍폜łȂ
                If TreeMailBox.SelectedNode.ImageIndex >= IconImage.Folder Then
                    ' q[{bNXSč폜
                    DeleteChildMailBox(TreeMailBox.SelectedNode)
                    If Not TreeMailBox.SelectedNode.Tag Is Nothing Then
                        ' [{bNX폜
                        Dim data As TreeNodeData = CType(TreeMailBox.SelectedNode.Tag, TreeNodeData)
                        imap.DeleteMailBox(data.Path)
                        TreeMailBox.SelectedNode.Remove()
                    End If
                End If
            Catch nex As nMail.nMailException
                MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
            End Try
        End If
    End Sub

    Private Sub Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer.Tick
        If TimerCount > 0 Then
            TimerCount = TimerCount - 1
            If (TimerCount = 0) And (imap.IsConnected()) Then
                ' 莞ԒʐM̏ꍇ No Operation R}h𔭍s
                Try
                    imap.NoOperation()
                    TimerCount = ContinueTimerCount
                    imap.StartIdle()
                Catch nex As nMail.nMailException
                    imap.Close()
                Catch ex As Exception
                    Debug.WriteLine(ex.Message)
                End Try
            End If
        End If
    End Sub

    Private Sub ContextMail_Popup(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContextMail.Popup
        ' Iꂽ[Ȃ΍폜͕s
        If ListMail.SelectedItems.Count = 0 Then
            MenuDelete.Enabled = False
            MenuReply.Enabled = False
            MenuProperty.Enabled = False
        Else
            MenuDelete.Enabled = True
            MenuReply.Enabled = True
            MenuProperty.Enabled = True
        End If
    End Sub

    Private Sub ContextTree_Popup(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContextTree.Popup
        Dim flag As Boolean = False
        Dim node As TreeNode = TreeMailBox.SelectedNode
        If Not node Is Nothing Then
            If node.ImageIndex >= IconImage.Folder Then
                flag = True
            End If
            Dim data As TreeNodeData = CType(TreeMailBox.SelectedNode.Tag, TreeNodeData)
            ' q[{bNX쐬ł邩H
            If (data.Flag And nMail.Imap4.MailBoxNoInferious) = 0 Then
                MenuCreateMailBox.Enabled = True
            Else
                MenuCreateMailBox.Enabled = False
            End If
            MenuDeleteMailBox.Enabled = flag
            MenuRenameMailBox.Enabled = flag
        End If
    End Sub

    Private Sub TreeMailBox_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TreeMailBox.KeyUp
        ' F2 L[Ń[{bNXOύXJn
        If (e.KeyCode = Keys.F2) And (Not TreeMailBox.SelectedNode Is Nothing) Then
            TreeMailBox.SelectedNode.BeginEdit()
        End If
    End Sub

    Private Sub TreeMailBox_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles TreeMailBox.DragDrop
        If e.Data.GetDataPresent(GetType(ListViewItem)) Then
            e.Effect = DragDropEffects.None
            Dim pt As Point = TreeMailBox.PointToClient(New Point(e.X, e.Y))
            Dim node As TreeNode = TreeMailBox.GetNodeAt(pt)
            If Not node Is Nothing Then
                Dim data As TreeNodeData = CType(node.Tag, TreeNodeData)
                If (node.ImageIndex <> IconImage.User) And ((data.Flag And nMail.Imap4.MailBoxNoSelect) = 0) Then
                    Dim item As ListViewItem = CType(e.Data.GetData(GetType(ListViewItem)), ListViewItem)
                    If Authenticate() Then
                        Try
                            ' hbvꂽ[hbv[{bNXɃRs[
                            Dim uid As Integer = CType(item.Tag, Integer)
                            imap.Copy(uid, data.Path)
                            e.Effect = DragDropEffects.Move
                        Catch nex As nMail.nMailException
                            MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
                        Catch ex As Exception
                            Debug.WriteLine(ex.Message)
                        End Try
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub TreeMailBox_DragEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles TreeMailBox.DragEnter
        e.Effect = DragDropEffects.None
        If e.Data.GetDataPresent(GetType(ListViewItem)) Then
            Dim pt As Point = TreeMailBox.PointToClient(New Point(e.X, e.Y))
            Dim node As TreeNode = TreeMailBox.GetNodeAt(pt)
            If Not node Is Nothing Then
                Dim data As TreeNodeData = CType(node.Tag, TreeNodeData)
                If (node.ImageIndex <> IconImage.User) And ((data.Flag And nMail.Imap4.MailBoxNoSelect) = 0) Then
                    e.Effect = DragDropEffects.Move
                End If
            End If
        End If
    End Sub

    Private Sub TreeMailBox_DragOver(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles TreeMailBox.DragOver
        e.Effect = DragDropEffects.None
        If e.Data.GetDataPresent(GetType(ListViewItem)) Then
            Dim pt As Point = TreeMailBox.PointToClient(New Point(e.X, e.Y))
            Dim node As TreeNode = TreeMailBox.GetNodeAt(pt)
            If Not node Is Nothing Then
                Dim data As TreeNodeData = CType(node.Tag, TreeNodeData)
                If (node.ImageIndex <> IconImage.User) And ((data.Flag And nMail.Imap4.MailBoxNoSelect) = 0) Then
                    e.Effect = DragDropEffects.Move
                End If
            End If
        End If
    End Sub

    Private Sub TreeMailBox_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TreeMailBox.MouseDown
        ' ENbN̍ۂɃ[{bNX̑IύX
        If e.Button = MouseButtons.Right Then
            Dim pt As Point = TreeMailBox.PointToClient(Cursor.Position)
            TreeMailBox.SelectedNode = TreeMailBox.GetNodeAt(pt)
        End If
    End Sub

    ' q[{bNX̖OύX
    Private Sub ChangeChildString(ByVal node As TreeNode, ByVal old_mailbox As String, ByVal new_mailbox As String)
        For Each tn As TreeNode In node.Nodes
            If Not tn.Tag Is Nothing Then
                Dim data As TreeNodeData = CType(tn.Tag, TreeNodeData)
                If data.Path.StartsWith(old_mailbox) Then
                    Dim path As String = new_mailbox + data.Path.Substring(old_mailbox.Length)
                    tn.Tag = New TreeNodeData(path, data.Separate, data.Flag)
                End If
            End If
            ChangeChildString(tn, old_mailbox, new_mailbox)
        Next
    End Sub

    Private Sub TreeMailBox_AfterLabelEdit(ByVal sender As System.Object, ByVal e As System.Windows.Forms.NodeLabelEditEventArgs) Handles TreeMailBox.AfterLabelEdit
        If (Not e.Label Is Nothing) And (e.Label <> e.Node.Text) Then
            Dim new_mailbox As String
            Dim old_mailbox As String
            Dim data As TreeNodeData = CType(e.Node.Tag, TreeNodeData)
            ' [{bNX擾
            old_mailbox = data.Path
            ' V[{bNX쐬
            Dim folder As String() = data.Path.Split(data.Separate)
            new_mailbox = ""
            If folder.Length > 1 Then
                new_mailbox = String.Join(data.Separate.ToString(), folder, 0, folder.Length - 1)
                new_mailbox += data.Separate.ToString()
            End If
            new_mailbox = new_mailbox + e.Label
            If Authenticate() Then
                Try
                    ' [{bNXύX
                    imap.RenameMailBox(old_mailbox, new_mailbox)
                    ' [{bNXXV
                    e.Node.Tag = New TreeNodeData(new_mailbox, data.Separate, data.Flag)
                    ' q[{bNX̍XV
                    ChangeChildString(e.Node, old_mailbox, new_mailbox)
                    Return
                Catch nex As nMail.nMailException
                    MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
                Catch ex As Exception
                    Debug.WriteLine(ex.Message)
                End Try
                e.CancelEdit = True
            End If
        Else
            e.CancelEdit = True
        End If
    End Sub

    Private Sub TreeMailBox_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeMailBox.AfterSelect
        If Not TreeMailBox.SelectedNode.Tag Is Nothing Then
            Dim data As TreeNodeData = CType(TreeMailBox.SelectedNode.Tag, TreeNodeData)
            If (data.Flag And nMail.Imap4.MailBoxNoSelect) = 0 Then
                MailBox = data.Path
                Try
                    GetMailList()
                    imap.StartIdle()
                Catch ex As Exception
                    Debug.WriteLine(ex.Message)
                End Try
            End If
        End If
    End Sub

    Private Sub TreeMailBox_BeforeLabelEdit(ByVal sender As System.Object, ByVal e As System.Windows.Forms.NodeLabelEditEventArgs) Handles TreeMailBox.BeforeLabelEdit
        ' [AhXƎMAMρAS~͕ύXs
        If (e.Node.ImageIndex <> IconImage.User) And (e.Node.ImageIndex < IconImage.Folder) Then
            e.CancelEdit = True
        End If
    End Sub

    Private Sub ListMail_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListMail.SelectedIndexChanged
        If ListMail.SelectedItems.Count > 0 Then
            If Authenticate() Then
                Try
                    TextBody.Text = ""
                    ' UID 擾
                    Dim uid As Integer = CType(ListMail.SelectedItems(0).Tag, Integer)
                    Dim count As Integer = 0
                    ' Ytt@C\Xgr[NA
                    ListAttach.Items.Clear()
                    ' Ytt@C̃ACRpC[WXgNA
                    ImageAttach.Images.Clear()
                    ' MIME \擾
                    imap.GetMimeStructure(uid)
                    Dim mime_list As nMail.Imap4.MimeStructureStatus() = imap.GetMimeStructureStatusList()
                    For Each mime As nMail.Imap4.MimeStructureStatus In mime_list
                        ' eLXgłΖ{ɕ\
                        If (String.Compare(mime.Type, "text", True) = 0) And (String.Compare(mime.SubType, "plain", True) = 0) Then
                            imap.GetMimePart(uid, mime.PartNo)
                            TextBody.Text = imap.Body
                        ElseIf String.Compare(mime.Type, "multipart", True) <> 0 Then
                            ' Ytt@Cł΁At@CƃACR
                            ' Ytt@C\Xgr[ɕ\
                            Dim name As String = mime.FileName
                            ' HTML [̖{̂ noname.html ɂȂ̂ŁA
                            ' Ƃ肠킩₷ȖOɕύX
                            If name = "noname.html" Then
                                name = "{.html"
                            End If
                            ' gqɑΉACR̎擾
                            Dim sf As SHFILEINFO = New SHFILEINFO
                            SHGetFileInfo(name, 0, sf, Marshal.SizeOf(sf), SHGFI_ICON Or SHGFI_SMALLICON Or SHGFI_USEFILEATTRIBUTES)
                            Dim icon As Icon = icon.FromHandle(sf.hIcon)
                            ' Ytt@C\Xgr[ɒǉ
                            ImageAttach.Images.Add(icon)
                            Dim add_item As ListViewItem = ListAttach.Items.Add(name, count)
                            count = count + 1
                            add_item.Tag = mime.PartNo
                        End If
                    Next
                    ' Ytt@C΃Xgr[\
                    ListAttach.Visible = False
                    If ListAttach.Items.Count > 0 Then
                        ListAttach.Visible = True
                    End If
                    ListMail.SelectedItems(0).SubItems(0).Text = ""

                    imap.StartIdle()
                Catch nex As nMail.nMailException
                    MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
                Catch ex As Exception
                    Debug.WriteLine(ex.Message)
                End Try
            End If
        End If
    End Sub

    Private Sub ListMail_ItemDrag(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ItemDragEventArgs) Handles ListMail.ItemDrag
        If Not e.Item Is Nothing Then
            If ListMail.DoDragDrop(CType(e.Item, ListViewItem), DragDropEffects.Move) = DragDropEffects.Move Then
                If Authenticate() Then
                    Try
                        ' hbO[폜
                        Dim item As ListViewItem = CType(e.Item, ListViewItem)
                        Dim uid As Integer = CType(item.Tag, Integer)
                        imap.Delete(uid)
                        ListMail.Items.Remove(item)
                        DeleteFlag = True
                        imap.StartIdle()
                    Catch nex As nMail.nMailException
                        MessageBox.Show(String.Format("G[܂B{0}", nex.Message))
                    Catch ex As Exception
                        Debug.WriteLine(ex.Message)
                    End Try
                End If
            End If
        End If
    End Sub

    Private Sub ListAttach_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListAttach.DoubleClick
        MenuOpenAttach_Click(sender, e)
    End Sub

End Class
